Bug 506533 - autofs init script and network init race condition
autofs init script and network init race condition
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: autofs (Show other bugs)
11
All Linux
low Severity medium
: ---
: ---
Assigned To: Ian Kent
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2009-06-17 12:46 EDT by Habig, Alec
Modified: 2010-06-28 09:06 EDT (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2010-06-28 09:06:19 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Habig, Alec 2009-06-17 12:46:44 EDT
Using autofs-5.0.4-31.i586.rpm (in response to bug #505381).

Unlike previous fedora versions where the network start was done directly by an init script, it's now handled by NetworkManager.  During boot, NetworkManager starts just before autofs.  However, NetworkManager is a daemon, its init script exits quickly, then the daemon takes its own sweet time bringing up eth0.

Then: autofs starts; tries to get a map over the non-existent network from ldap and fails; resulting in no automount maps (which in my case means no home directories for users).  It does not retry later, although a manual daemon restart works.

Ugly workaround - I inserted a "sleep 15" in the autofs init script to allow the network to catch up.  However, I see that the autofs script lists a network dependency, as it should.

So, how is this dependency enforced?  Should the autofs script be testing something to ensure there really is a network connection?  Or should NetworkManager be made to wait till it actually has a network before exiting its init script?  (in which case this bug should belong to it not autofs).

This problem effects any other service which is expecting a network, although most recover on their own.
Comment 1 Orion Poplawski 2009-09-30 17:50:29 EDT
The way I handle this, and perhaps an acceptable general solution, is the following script in /etc/NetworkManager/dispatcher.d:

#!/bin/bash

if [ -x /usr/bin/logger ]; then
  LOGGER="/usr/bin/logger -s -p user.notice -t NetworkManagerDispatcher"
else
  LOGGER=echo
fi

if [ -n "$1" ]; then
  if /sbin/service autofs status >& /dev/null
  then
    $LOGGER "performing autofs reload"
    /sbin/service autofs reload
  fi
fi
Comment 2 Bug Zapper 2010-04-27 11:01:56 EDT
This message is a reminder that Fedora 11 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 11.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '11'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 11's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 11 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 3 Bug Zapper 2010-06-28 09:06:19 EDT
Fedora 11 changed to end-of-life (EOL) status on 2010-06-25. Fedora 11 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.